/*
 * EnrollInPoolOperation.hpp
 *
 *  Created on: Feb 26, 2012
 *      Author: heber
 */

#ifndef ENROLLINPOOLOPERATION_HPP_
#define ENROLLINPOOLOPERATION_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <boost/asio.hpp>
#include <string>
#include <vector>

#include "Connection.hpp"

#include "Controller/Commands/Operation.hpp"
#include "Jobs/FragmentJob.hpp"
#include "Results/FragmentResult.hpp"
#include "WorkerAddress.hpp"

class EnrollInPoolOperation : public Operation  {
public:
  /// Constructor for class EnrollInPoolOperation.
  EnrollInPoolOperation(Connection &_connection, const WorkerAddress &_address) :
    Operation(std::string("enrollinpool"),_connection),
    address(_address),
    flag(Success)
  {}
  /// Destructor for class EnrollInPoolOperation
  ~EnrollInPoolOperation() {}

  enum EnrollFlag {
    Success,
    Fail
  };

protected:
  // virtual function pointer to the connection handler
  void handle_connect(const boost::system::error_code& e,
      boost::asio::ip::tcp::resolver::iterator endpoint_iterator);

  /// Handle sent of address
  void handle_sendAddress(const boost::system::error_code& e);

  /// Handle sent of address
  void handle_FinishOperation(const boost::system::error_code& e);

private:
  //!> address to enroll with
  WorkerAddress address;

  //!> flag returned by worker pool after enroll request
  enum EnrollFlag flag;
};


#endif /* ENROLLINPOOLOPERATION_HPP_ */
